-- indoorSound15.lua
-- Author RivalBomb
--
-- 05.01.2016


indoorSound15 = {};

function indoorSound15.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Motorized, specializations);
end;

function indoorSound15:load(xmlFile)
	self.swapSounds = SpecializationUtil.callSpecializationsFunction("swapSounds");

	self.soundSwitched = false;
	self.volume = 1;
	
	if self.isClient then
		self.motorStartSoundOutside = Utils.loadSample(xmlFile, {}, "vehicle.motorStartSound", nil, self.baseDirectory, self.components[1].node);
		self.motorIdleSoundOutside = Utils.loadSample(xmlFile, {}, "vehicle.motorSound", nil, self.baseDirectory, self.components[1].node);
		self.motorSoundRunOutside = Utils.loadSample(xmlFile, {}, "vehicle.motorSoundRun", nil, self.baseDirectory, self.components[1].node);
		self.motorStopSoundOutside = Utils.loadSample(xmlFile, {}, "vehicle.motorStopSound", nil, self.baseDirectory, self.components[1].node);

		self.motorStartSoundInside = Utils.loadSample(xmlFile, {}, "vehicle.motorStartSoundInside", nil, self.baseDirectory, self.components[1].node);
		self.motorIdleSoundInside = Utils.loadSample(xmlFile, {}, "vehicle.motorSoundInside", nil, self.baseDirectory, self.components[1].node);
		self.motorSoundRunInside = Utils.loadSample(xmlFile, {}, "vehicle.motorSoundRunInside", nil, self.baseDirectory, self.components[1].node);
		self.motorStopSoundInside = Utils.loadSample(xmlFile, {}, "vehicle.motorStopSoundInside", nil, self.baseDirectory, self.components[1].node);
	end;
end;

function indoorSound15:postLoad()
	if self.dCdeactivateModule ~= nil then
		self:dCdeactivateModule("inDoorSound");
	end;
end;

function indoorSound15:onLeave()
	self:swapSounds("outside");
	self.soundSwitched = false;
end;

function indoorSound15:delete()
end;

function indoorSound15:mouseEvent(posX, posY, isDown, isUp, button)
end;

function indoorSound15:keyEvent(unicode, sym, modifier, isDown)
end;

function indoorSound15:update(dt)
	if self:getIsActive() and self.isClient then
		if (self.cameras[self.camIndex].isInside and self.animations["winFrontSource"].currentTime < 500 and self.animations["doorLeftSource"].currentTime < 10 and self.animations["doorRightSource"].currentTime < 10 and self.animations["winFrontSource2"].currentTime < 500)
		and (not self.soundSwitched) and (self.isEntered) then
			self:swapSounds("inside");
			self.soundSwitched = true;
		elseif (not self.cameras[self.camIndex].isInside and self.soundSwitched) or (self.isEntered == false and self.soundSwitched)
		or ((self.animations["winFrontSource"].currentTime > 500 or self.animations["doorLeftSource"].currentTime > 10 or self.animations["doorRightSource"].currentTime > 10 or self.animations["winFrontSource2"].currentTime > 500) and self.soundSwitched) then
			self:swapSounds("outside");
			self.soundSwitched = false;
		end;
	end;
end;

function indoorSound15:updateTick(dt)
end;

function indoorSound15:draw()
end;

function indoorSound15:swapSounds(camInOut)
	if Utils.isSamplePlaying(self.sampleMotor) then
		Utils.stopSample(self.sampleMotor, true);
	end;
	if Utils.isSamplePlaying(self.sampleMotorStart) then
		Utils.stopSample(self.sampleMotorStart, true);
	end;
	if Utils.isSamplePlaying(self.sampleMotorStop) then
		Utils.stopSample(self.sampleMotorStop, true);
	end;
	if Utils.isSamplePlaying(self.sampleMotorRun) then
		Utils.stopSample(self.sampleMotorRun, true);
	end;

	if camInOut == "outside" then
		self.sampleMotorStart = self.motorStartSoundOutside;
		self.sampleMotorStop = self.motorStopSoundOutside;
		self.sampleMotor = self.motorIdleSoundOutside;
		self.sampleMotorRun = self.motorSoundRunOutside;
		self.sampleMotorRun.pitchOffset = self.motorSoundRunOutside.pitchOffset;
		self.sampleMotorRun.pitchMax = self.motorSoundRunOutside.pitchMax;
	elseif camInOut == "inside" then
		self.sampleMotorStart = self.motorStartSoundInside;
		self.sampleMotorStop = self.motorStopSoundInside;
		self.sampleMotor = self.motorIdleSoundInside;
		self.sampleMotorRun = self.motorSoundRunInside;
		self.sampleMotorRun.pitchOffset = self.motorSoundRunInside.pitchOffset;
		self.sampleMotorRun.pitchMax = self.motorSoundRunInside.pitchMax;
	end;
	if self.isClient and self.isEntered and self.isMotorStarted then
		Utils.playSample(self.sampleMotor, 0,0,nil);
		Utils.playSample(self.sampleMotorRun, 0,0,nil);
	end;
	if self.isClient and not self.isEntered then
		Utils.stopSample(self.motorIdleSoundInside, true);
		Utils.stopSample(self.motorSoundRunInside, true);
	end;
end;